<?php

namespace GreenwayDirectService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for authenticationType StructType
 * @subpackage Structs
 */
class AuthenticationType extends AbstractStructBase
{
    /**
     * The siteCode
     * Meta informations extracted from the WSDL
     * - type: xs:string
     * @var siteCode
     */
    public $siteCode;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * Constructor method for authenticationType
     * @uses AuthenticationType::setSiteCode()
     * @uses AuthenticationType::setPassword()
     * @param siteCode $siteCode
     * @param string $password
     */
    public function __construct(siteCode $siteCode = null, $password = null)
    {
        $this
            ->setSiteCode($siteCode)
            ->setPassword($password);
    }
    /**
     * Get siteCode value
     * @return siteCode|null
     */
    public function getSiteCode()
    {
        return $this->siteCode;
    }
    /**
     * Set siteCode value
     * @param siteCode $siteCode
     * @return \GreenwayDirectService\StructType\AuthenticationType
     */
    public function setSiteCode(siteCode $siteCode = null)
    {
        $this->siteCode = $siteCode;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \GreenwayDirectService\StructType\AuthenticationType
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \GreenwayDirectService\StructType\AuthenticationType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
