<?php

namespace GreenwayDirectService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for driverDetailsType StructType
 * @subpackage Structs
 */
class DriverDetailsType extends AbstractStructBase
{
    /**
     * The title
     * Meta informations extracted from the WSDL
     * - type: xs:string
     * @var title
     */
    public $title;
    /**
     * The firstName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - type: xs:string
     * @var firstName
     */
    public $firstName;
    /**
     * The lastName
     * Meta informations extracted from the WSDL
     * - type: xs:string
     * @var lastName
     */
    public $lastName;
    /**
     * The address
     * @var mixed
     */
    public $address;
    /**
     * The countryOfResidence
     * @var mixed
     */
    public $countryOfResidence;
    /**
     * The dateOfBirth
     * @var mixed
     */
    public $dateOfBirth;
    /**
     * The email
     * @var mixed
     */
    public $email;
    /**
     * The licence
     * @var mixed
     */
    public $licence;
    /**
     * Constructor method for driverDetailsType
     * @uses DriverDetailsType::setTitle()
     * @uses DriverDetailsType::setFirstName()
     * @uses DriverDetailsType::setLastName()
     * @uses DriverDetailsType::setAddress()
     * @uses DriverDetailsType::setCountryOfResidence()
     * @uses DriverDetailsType::setDateOfBirth()
     * @uses DriverDetailsType::setEmail()
     * @uses DriverDetailsType::setLicence()
     * @param title $title
     * @param firstName $firstName
     * @param lastName $lastName
     * @param mixed $address
     * @param mixed $countryOfResidence
     * @param mixed $dateOfBirth
     * @param mixed $email
     * @param mixed $licence
     */
    public function __construct(title $title = null, firstName $firstName = null, lastName $lastName = null, $address = null, $countryOfResidence = null, $dateOfBirth = null, $email = null, $licence = null)
    {
        $this
            ->setTitle($title)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setAddress($address)
            ->setCountryOfResidence($countryOfResidence)
            ->setDateOfBirth($dateOfBirth)
            ->setEmail($email)
            ->setLicence($licence);
    }
    /**
     * Get title value
     * @return title|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param title $title
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setTitle(title $title = null)
    {
        $this->title = $title;
        return $this;
    }
    /**
     * Get firstName value
     * @return firstName|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param firstName $firstName
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setFirstName(firstName $firstName = null)
    {
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get lastName value
     * @return lastName|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param lastName $lastName
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setLastName(lastName $lastName = null)
    {
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Get address value
     * @return mixed|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param mixed $address
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setAddress($address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get countryOfResidence value
     * @return mixed|null
     */
    public function getCountryOfResidence()
    {
        return $this->countryOfResidence;
    }
    /**
     * Set countryOfResidence value
     * @param mixed $countryOfResidence
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setCountryOfResidence($countryOfResidence = null)
    {
        $this->countryOfResidence = $countryOfResidence;
        return $this;
    }
    /**
     * Get dateOfBirth value
     * @return mixed|null
     */
    public function getDateOfBirth()
    {
        return $this->dateOfBirth;
    }
    /**
     * Set dateOfBirth value
     * @param mixed $dateOfBirth
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setDateOfBirth($dateOfBirth = null)
    {
        $this->dateOfBirth = $dateOfBirth;
        return $this;
    }
    /**
     * Get email value
     * @return mixed|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @param mixed $email
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setEmail($email = null)
    {
        $this->email = $email;
        return $this;
    }
    /**
     * Get licence value
     * @return mixed|null
     */
    public function getLicence()
    {
        return $this->licence;
    }
    /**
     * Set licence value
     * @param mixed $licence
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public function setLicence($licence = null)
    {
        $this->licence = $licence;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \GreenwayDirectService\StructType\DriverDetailsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
